
#include "xorotypes.h"



// Seed the state array.  Seed MUST not be all zero.
static rngword_t  s[2] = {1, 0};


// Xoroshiro with scrambler offset and engine feedback
rngword_t  nextrnd( void )
{
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	rngword_t  s0 = s[0];
	rngword_t  s1 = s[1];
#else
	rngword_t  s0 = s[0] & ACCUM_MASK;
	rngword_t  s1 = s[1] & ACCUM_MASK;
#endif

	// New addition from authors:  Second stage summing (scrambler) for Xoroshiro++
//	rngword_t  result = rotl( s0 + s1, CONSTANT_D ) + s0;
	rngword_t  result = rotl( s0 + s1, CONSTANT_D ) + (s0 - CONSTANT_E);  // with experimental CONSTANT_E

// Iterator (Engine)
	s1 ^= s0;
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
//	s[0] = rotl( s0, CONSTANT_A ) ^ s1 ^ (s1 << CONSTANT_B);  // where integer word size matches the engine word size
	s[0] = rotl( s0, CONSTANT_A ) ^ (CONSTANT_M) ^ s1 ^ (s1 << CONSTANT_B);  // with experimental CONSTANT_E
#else
//	s[0] = rotl( s0, CONSTANT_A ) ^ s1 ^ (s1 << CONSTANT_B) & ACCUM_MASK;
	s[0] = rotl( s0, CONSTANT_A ) ^ (CONSTANT_M) ^ s1 ^ (s1 << CONSTANT_B) & ACCUM_MASK;  // with experimental CONSTANT_E
#endif
	s[1] = rotl( s1, CONSTANT_C );


#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	return( result );  // where integer word size matches the engine word size
#else
	return( result & ACCUM_MASK );
#endif
}
