#ifndef	XOROTYPES_H
#define XOROTYPES_H

#include <stdint.h>

//#define  ACCUM_SIZE  16   // Passed in as -D gcc parameter. (Min=8+WORD_POSITION, Max=64) Bit width of generated random numbers.


#if ACCUM_SIZE > 32
	#define  ACCUM_MASK  (((1ULL<<(ACCUM_SIZE-1))-1)<<1|1)  // Bit of a shuffle to work on all 64 bits :)
	#define  SAMPLE_MASK  (((1ULLL<<(SAMPLE_SIZE-1))-1)<<1|1)  // ditto
	typedef  uint64_t  rngword_t;
	typedef  unsigned int128_t  drnword_t;
#elif ACCUM_SIZE > 16
	#define  ACCUM_MASK  (((1UL<<(ACCUM_SIZE-1))-1)<<1|1)   // max 32 bits
	#define  SAMPLE_MASK  (((1ULL<<(SAMPLE_SIZE-1))-1)<<1|1)
	typedef  uint32_t  rngword_t;
	typedef  uint64_t  drnword_t;
#else
	#define  ACCUM_MASK  (((1U<<(ACCUM_SIZE-1))-1)<<1|1)    // max 16 bits
	#define  SAMPLE_MASK  (((1UL<<(SAMPLE_SIZE-1))-1)<<1|1)
	typedef  uint16_t  rngword_t;
	typedef  uint32_t  drnword_t;
#endif
#define  ACCUM_DMASK  ((ACCUM_MASK<<ACCUM_SIZE)|ACCUM_MASK)



extern rngword_t  nextrnd( void );



#ifdef dITER
static inline drnword_t  rotr( drnword_t value, int shift )
{
	#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	return (value >> shift) | (value << (ACCUM_SIZE*2 - shift));
	#else
	return ((value >> shift) | ((value & ACCUM_DMASK) << (ACCUM_SIZE*2 - shift))) & ACCUM_DMASK;
	#endif
}
#else
static inline rngword_t  rotr( rngword_t value, int shift )
{
	#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	return (value >> shift) | (value << (ACCUM_SIZE - shift));
	#else
	return ((value >> shift) | ((value & ACCUM_MASK) << (ACCUM_SIZE - shift))) & ACCUM_MASK;
	#endif
}
#endif



static inline rngword_t  rotl( rngword_t value, int shift )  {
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	return (value << shift) | (value >> (ACCUM_SIZE - shift));
#else
	return ((value << shift) | ((value & ACCUM_MASK) >> (ACCUM_SIZE - shift))) & ACCUM_MASK;
#endif
}

#endif
